## minisat+ 1.0

=== Makefile ===
##
##  Makefile for Standard, Profile, Debug, and Release version of MiniSat
##

CSRCS     = $(wildcard *.C)
CHDRS     = $(wildcard *.h)
COBJS     = $(addsuffix .o, $(basename $(CSRCS))) ADTs/Global.o ADTs/FEnv.o ADTs/File.o
#COBJS     = PbSolver_convertSort.o PbSolver.o PbSolver_convertAdd.o PbSolver_convertBdd.o PbSolver_convert.o Debug.o Hardware_adders.o Hardware_clausify.o Hardware_sorters.o Main.o MiniSat.o PbParser.o SatELite.o ADTs/Global.o ADTs/FEnv.o ADTs/File.o
PCOBJS    = $(addsuffix p,  $(COBJS))
DCOBJS    = $(addsuffix d,  $(COBJS))
RCOBJS    = $(addsuffix r,  $(COBJS))
R64COBJS  = $(addsuffix x,  $(COBJS))

EXEC      = minisat+

CXX       = g++
#CXX      = icpc
CFLAGS    = -Wall -ffloat-store 
CFLAGS   += -IADTs -include Global.h -include Main.h -D_FILE_OFFSET_BITS=64 
COPTIMIZE = -O3 #-fomit-frame-pointer # -falign-loops=4 -falign-functions=16 -foptimize-sibling-calls -finline-functions -fcse-follow-jumps -fcse-skip-blocks -frerun-cse-after-loop -frerun-loop-opt -fgcse


.PHONY : s p d r build clean depend

s:	WAY=standard
p:	WAY=profile
d:	WAY=debug
r:	WAY=release
rs:	WAY="release static / bignums"
rx:	WAY="release static / 64-bit integers"

s:	CFLAGS+=$(COPTIMIZE) -ggdb -D DEBUG
p:	CFLAGS+=$(COPTIMIZE) -pg -ggdb -D DEBUG
d:	CFLAGS+=-O0 -ggdb -D DEBUG
r:	CFLAGS+=$(COPTIMIZE) -D NDEBUG
rs:	CFLAGS+=$(COPTIMIZE) -D NDEBUG
rx:	CFLAGS+=$(COPTIMIZE) -D NDEBUG -D NO_GMP

s:	build $(EXEC)
p:	build $(EXEC)_profile
d:	build $(EXEC)_debug
r:	build $(EXEC)_release
rs:	build $(EXEC)_bignum_static
rx:	build $(EXEC)_64-bit_static

build:
	@echo Building $(EXEC) "("$(WAY)")"

clean:
	@rm -f $(EXEC) $(EXEC)_profile $(EXEC)_debug $(EXEC)_release $(EXEC)_static \
	  $(COBJS) $(PCOBJS) $(DCOBJS) $(RCOBJS) $(R64COBJS) depend.mak

## Build rule
%.o %.op %.od %.or %.ox: %.C
	@echo Compiling: $<
	@$(CXX) $(CFLAGS) -c -o $@ $<

## Linking rules (standard/profile/debug/release)
$(EXEC): $(COBJS)
	@echo Linking $(EXEC)
	@$(CXX) $(COBJS) -lz -lgmp -ggdb -Wall -o $@ 

$(EXEC)_profile: $(PCOBJS)
	@echo Linking $@
	@$(CXX) $(PCOBJS) -lz -lgmp -ggdb -Wall -pg -o $@

$(EXEC)_debug:	$(DCOBJS)
	@echo Linking $@
	@$(CXX) $(DCOBJS) -lz -lgmp -ggdb -Wall -o $@

$(EXEC)_release: $(RCOBJS)
	@echo Linking $@
	@$(CXX) $(RCOBJS) -lz -lgmp -Wall -o $@

$(EXEC)_bignum_static: $(RCOBJS)
	@echo Linking $@
	@$(CXX) --static $(RCOBJS) -lz -lgmp -Wall -o $@

$(EXEC)_64-bit_static: $(R64COBJS)
	@echo Linking $@
	@$(CXX) --static $(R64COBJS) -lz -Wall -o $@


## Make dependencies
depend:	depend.mak
depend.mak:	$(CSRCS) $(CHDRS)
	@echo Making dependencies...
	@$(CXX) -MM $(CSRCS) $(CFLAGS) > depend.mak
	@cp depend.mak /tmp/depend.mak.tmp
	@sed "s/o:/op:/" /tmp/depend.mak.tmp >> depend.mak
	@sed "s/o:/od:/" /tmp/depend.mak.tmp >> depend.mak
	@sed "s/o:/or:/" /tmp/depend.mak.tmp >> depend.mak
	@sed "s/o:/ox:/" /tmp/depend.mak.tmp >> depend.mak
	@rm /tmp/depend.mak.tmp

include depend.mak

=== debian/changelog ===
minisat+ (1.0-5) unstable; urgency=medium

  * Team upload.
  
  [ Andreas Tille ]
  * Packaging on Salsa
  * Point watch file to Github
    Closes: #958287
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Rules-Requires-Root: no (routine-update)

  [ Helmut Grohne ]
  * Fix FTCBFS: Pass a cross CXX to clean.
    Closes: #1033990

 -- Andreas Tille <tille@debian.org>  Thu, 26 Sep 2024 14:38:34 +0200

minisat+ (1.0-4) unstable; urgency=medium

  * debian/tests/control: add Depends: @ for test "upstream".

 -- Ralf Treinen <treinen@debian.org>  Sun, 19 Feb 2017 17:03:19 +0100

minisat+ (1.0-3) unstable; urgency=medium

  * debian/copyright: machine-readable format 1.0
  * Standards-version 3.9.8 (no change)
  * Debhelper compatibility level 10:
    - bump debian/compat
    - bump build-dependency on debhelper
  * Vcs-{Git,Browser}: secure URI
  * patch spelling: fix typo in help text
  * add as-installed package test

 -- Ralf Treinen <treinen@debian.org>  Mon, 19 Dec 2016 08:06:16 +0100

minisat+ (1.0-2) unstable; urgency=low

  * Patch exitcode: non-null exit code on parse error.

 -- Ralf Treinen <treinen@debian.org>  Tue, 24 May 2011 20:42:23 +0200

minisat+ (1.0-1) unstable; urgency=low

  * Initial package (closes: Bug#626410)

 -- Ralf Treinen <treinen@debian.org>  Thu, 12 May 2011 22:13:24 +0200

=== debian/control ===
Source: minisat+
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libgmp-dev,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/minisatp
Vcs-Git: https://salsa.debian.org/science-team/minisatp.git
Homepage: http://minisat.se/MiniSat+.html
Rules-Requires-Root: no

Package: minisat+
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: solver for pseudo-Boolean constraints
 MinSat+ is a solver for Pseudo-Boolean Optimization (AKA 0-1
 integer programming) that is based on the MiniSat SAT-solver. It
 supports optimizing a linear objective function, subject to a set
 of linear constraints. The variables of the objective function
 and constraints are boolean, i.e. required to be 0 or
 1. Pseudo-Boolean optimization can be used to solve many kinds of
 combinatorial optimization problems. This version of Minisat+ is
 compiled with bignum support for constraint coefficients.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildtools.mk

%:
	dh $@

override_dh_auto_make:
	make rs

override_dh_auto_clean:
	make clean CXX=$(CXX)

=== debian/watch ===
version=4

opts="mode=git, dversionmangle=auto" \
   https://github.com/niklasso/minisatp.git refs/tags/v?@ANY_VERSION@
